/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.liferay.headless.delivery.client.dto.v1_0;

import com.liferay.headless.delivery.client.function.UnsafeSupplier;
import com.liferay.headless.delivery.client.serdes.v1_0.FragmentFieldHTMLSerDes;

import java.util.Objects;

import javax.annotation.Generated;

/**
 * @author Javier Gamarra
 * @generated
 */
@Generated("")
public class FragmentFieldHTML implements Cloneable {

	public static FragmentFieldHTML toDTO(String json) {
		return FragmentFieldHTMLSerDes.toDTO(json);
	}

	public Object getHtml() {
		return html;
	}

	public void setHtml(Object html) {
		this.html = html;
	}

	public void setHtml(UnsafeSupplier<Object, Exception> htmlUnsafeSupplier) {
		try {
			html = htmlUnsafeSupplier.get();
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	protected Object html;

	@Override
	public FragmentFieldHTML clone() throws CloneNotSupportedException {
		return (FragmentFieldHTML)super.clone();
	}

	@Override
	public boolean equals(Object object) {
		if (this == object) {
			return true;
		}

		if (!(object instanceof FragmentFieldHTML)) {
			return false;
		}

		FragmentFieldHTML fragmentFieldHTML = (FragmentFieldHTML)object;

		return Objects.equals(toString(), fragmentFieldHTML.toString());
	}

	@Override
	public int hashCode() {
		String string = toString();

		return string.hashCode();
	}

	public String toString() {
		return FragmentFieldHTMLSerDes.toJSON(this);
	}

}